package explorviz.live_trace_processing.main;

import java.util.concurrent.TimeUnit;

import explorviz.live_trace_processing.configuration.Configuration;
import explorviz.live_trace_processing.configuration.ConfigurationFactory;
import explorviz.live_trace_processing.filter.ITraceSink;
import explorviz.live_trace_processing.filter.reconstruction.ITraceReconstruction;
import explorviz.live_trace_processing.filter.reconstruction.TraceReconstructionFilter;
import explorviz.live_trace_processing.filter.reduction.ITraceReduction;
import explorviz.live_trace_processing.filter.reduction.TracesSummarizationFilter;
import explorviz.live_trace_processing.reader.TCPReader;

public class FilterConfiguration {
	public static void configureAndStartFilters(final Configuration configuration,
			final ITraceSink sink) {
		final boolean isWorker = configuration
				.getBooleanProperty(ConfigurationFactory.WORKER_ENABLED);

		// final IRecordCounting recordCounting = new
		// RecordCountingFilter(sink);

		final ITraceReduction traceReduction = new TracesSummarizationFilter(
				TimeUnit.MILLISECONDS.toNanos(990), sink);

		// final PatternSummarizationFilter oneTraceReduction = new
		// PatternSummarizationFilter(
		// traceReduction, 300, 1);

		final ITraceReconstruction traceReconstruction = new TraceReconstructionFilter(
				TimeUnit.SECONDS.toNanos(4), traceReduction);

		new TCPReader(configuration.getIntProperty(ConfigurationFactory.READER_LISTENING_PORT,
				10133), isWorker, traceReconstruction).read();
	}
}
